(defun c:ASCORTANTE (/ *error* op_file fname dcl d b ø fc fy Vu Av Vc Vs Vu_max Av_s Av_min_s s1 s2 s3 N1)

  (defun *error* (msg)
    (and
      msg
      (not (wcmatch (strcase msg) "*CANCEL*,*EXIT*,*QUIT*,*BREAK*"))
      (princ (strcat "\nError: " msg))
    )
    (if fname (vl-catch-all-apply 'vl-file-delete (list fname)))
    (princ)
  )

  (setq
    fname (vl-filename-mktemp "CORTANTE" (getvar 'dwgprefix) ".dcl")
    op_file (open fname "w")
  )

  (foreach x
    '("CORTANTE : dialog { label = \"DISEÑO DE CORTANTE - LUIS CARDENAS\";"
      ": column {"
      "  : row { : text { label = \"Peralte efectivo de la viga d (cm):\"; alignment = left; width = 50; } : edit_box { key = \"d\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Ancho de la viga b (cm):\"; alignment = left; width = 50; } : edit_box { key = \"b\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Factor de Reducción por cortante ø:\"; alignment = left; width = 50; } : edit_box { key = \"ø\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Resistencia a la compresión simple del concreto f'c (kg/cm²):\"; alignment = left; width = 50; } : edit_box { key = \"fc\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Módulo de Fluencia del Acero fy (kg/cm²):\"; alignment = left; width = 50; } : edit_box { key = \"fy\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Fuerza cortante Amplificada Vu (kg):\"; alignment = left; width = 50; } : edit_box { key = \"Vu\"; alignment = left; width = 12; } }"
      "  : row { : text { label = \"Área del estribo que resiste cortante Av (cm²):\"; alignment = left; width = 50; } : edit_box { key = \"Av\"; alignment = left; width = 12; } }"
      "}"
      "ok_cancel;"
      "}"
    )
    (write-line x op_file)
  )
  
  (close op_file)

  (if
    (and
      (> (setq dcl (load_dialog fname)) 0)
      (new_dialog "CORTANTE" dcl)
    )
    (progn
      (setq d 0 b 0 ø 0 fc 0 fy 0 Vu 0 Av 0)
      (action_tile "d" "(setq d (atof $value))")
      (action_tile "b" "(setq b (atof $value))")
      (action_tile "ø" "(setq ø (atof $value))")
      (action_tile "fc" "(setq fc (atof $value))")
      (action_tile "fy" "(setq fy (atof $value))")
      (action_tile "Vu" "(setq Vu (atof $value))")
      (action_tile "Av" "(setq Av (atof $value))")
      (setq r (start_dialog))
      (unload_dialog dcl)
    )
  )

  (if (= r 1)
    (progn
      (setq Vc (* 0.53 (sqrt fc) b d))
      (setq Vs (- (/ Vu ø) Vc))
      (setq Vu_max (+ Vc (* 2.2 (sqrt fc) b d)))

      (if (> Vu Vu_max)
        (setq Av_s "Aumentar dimensiones de la viga")
        (if (<= Vu (* ø 0.27 (sqrt fc) b d))
          (setq Av_s 0)
          (setq Av_s (/ (- Vu (* ø Vc)) (* ø fy d)))
        )
      )

      (setq Av_min_s (max (/ (* 0.2 (sqrt fc) b) fy) (/ (* 3.5 b) fy)))
      (setq s1 (/ Av (max Av_s Av_min_s)))
      (setq s2 (min 30 (max (/ d 4) 10)))
      (setq s3 30)
      (setq N1 (fix (+ (/ (* 2 d) (min s1 s2)) 3)))

      (alert (strcat
               "Vu: " (rtos Vu 2 2) " kg\n"
               "Vu_max: " (rtos Vu_max 2 2) " kg\n"
               "Av/s: " (rtos Av_s 2 4) " cm²/cm\n"
               "Av_min/s: " (rtos Av_min_s 2 4) " cm²/cm\n\n"
               "1@5, " (itoa N1) "@ " (rtos (min s1 s2) 2 2) ", R@" (rtos s3 2 0) "cm"))
    )
  )

  (*error* nil)
  (princ)
)

(princ "Creado por: LUIS CARDENAS, neoluist@gmail.com, www.ingenieriafacil.com, https://beacons.ai/neoluist")
